package edu.ucf.rp2;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.concurrent.CountDownLatch;

import org.apache.commons.io.IOUtils;


public class WebFetcher extends Thread
{
	private final String userAgent = 
			"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/535.19 (KHTML, like Gecko) Chrome/18.0.1025.168";
	
	private String inputUrl;
	private CountDownLatch stopLatch;
	private String source = "";
	private int statusCode;
	
	public WebFetcher (String inputUrl) {
		this.inputUrl = inputUrl;
	}
	
	public WebFetcher (String inputUrl, CountDownLatch stopLatch) {
		this.inputUrl = inputUrl;
		this.stopLatch = stopLatch;
	}
	
	public void run () {	
		try {
			fetch();
		} catch (MalformedURLException mue) {
			mue.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		} finally {
			stopLatch.countDown();
		}
	}
	
	public void exec () {
		try {
			fetch();
		} catch (MalformedURLException mue) {
			mue.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}
	
	private void fetch () throws MalformedURLException, IOException {
		URL url = new URL(inputUrl);
		HttpURLConnection connection = (HttpURLConnection) url.openConnection();
		connection.setRequestProperty("User-Agent", userAgent);
		connection.connect();
		
		statusCode = connection.getResponseCode();
		if (isOKCode()) {
			InputStream htmlStream = connection.getInputStream();
			source = IOUtils.toString(htmlStream);
		}
	}
	
	public boolean isOKCode () {
		if (statusCode>=200 && statusCode<300) {
			return true;
		} else {
			return false;
		}
	}
	
	public String getSource () {
		return source;
	}
	
	public int getStatusCode () {
		return statusCode;
	}
	
}
