package edu.ucf.rp2;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import org.apache.commons.io.IOUtils;


public class WebSource
{
	private final static String userAgent = "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/535.19 (KHTML, like Gecko) Chrome/18.0.1025.168";

	public static String get (String url) throws IOException
	{		
		URL searchUrl = new URL(url);
		URLConnection connection = searchUrl.openConnection();
		connection.setRequestProperty("User-Agent", userAgent);
		connection.connect();
		InputStream htmlStream = connection.getInputStream();
		 
		return IOUtils.toString(htmlStream);
	}
	
	
	
	/**
	 * Produces a file containing the HTML of a Google search query
	 * <p>
	 * 
	 * @param fileName        the name of the output file
	 * @throws IOException
	 */
	public static void print (String webSource, String fileName) throws IOException 
	{	
		BufferedWriter outputWriter = new BufferedWriter(new FileWriter(fileName));
		outputWriter.write(webSource);
		outputWriter.close();
	}
	
	
	
	/**
	 * Produces a file containing the HTML of a web page
	 * <p>
	 * 
	 * @param fileName        the name of the output file
	 * @param outputDirectory the directory where the file will be created
	 * @throws IOException
	 */
	public static void print (String webSource, String fileName, String outputDirectory) throws IOException 
	{	
		String filePath = outputDirectory + fileName;
		
		BufferedWriter outputWriter = new BufferedWriter(new FileWriter(filePath));
		outputWriter.write(webSource);
		outputWriter.close();
	}
	
	
	
}